<!DOCTYPE html>
<html lang="en">

<head>
  <title>List All Order - Dattt</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script src="crud.js"></script>
</head>

<body>
  <!-- Filter -->
  <div class="container">
    <div class="text-center mt-3 mb-3">
      <h2>DANH SÁCH ĐƠN HÀNG</h2>
    </div>

    <div class="row form-group">
      <div class="col-sm-5">
        <div class="row pl-3">
          <label class="col-form-label" for="sel-order-status"><b>Trạng thái Order</b></label>
          <div class="col-sm-8">
            <select id="sel-order-status" class="form-control">
              <option value="all">All</option>
              <option value="open">Open</option>
              <option value="confirmed">Confirmed</option>
              <option value="cancel">Cancel</option>
            </select>
          </div>
        </div>
      </div>

      <div class="col-sm-5">
        <div class="row pl-3">
          <label class="col-form-label" for="sel-pizza-type"><b>Loại pizza</b></label>
          <div class="col-sm-8">
            <select id="sel-pizza-type" class="form-control">
              <option value="all">All</option>
              <option value="hawaii">Hawaii</option>
              <option value="bacon">Bacon</option>
              <option value="seafood">Seafood</option>
            </select>
          </div>
        </div>
      </div>

      <div class="col-sm-2">
        <button class="btn btn-success w-100" id="btn-filter">Lọc</button>
      </div>
    </div>
  </div>

  <!-- Table -->
  <div class="container-fluid mt-2">
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-new"><i class="fa fa-plus"></i>&nbsp; Thêm</button>
    </div>

    <table id="table-orders" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Order code</th>
          <th>Kích cỡ combo</th>
          <th>Loại pizza</th>
          <th>Nước uống</th>
          <th>Thành tiền</th>
          <th>Họ và tên</th>
          <th>Số điện thoại</th>
          <th>Trạng thái</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody> </tbody>
    </table>
  </div>

  <!-- Create Modal -->
  <div id="create-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title"> Create Order !!! </h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <!-- Body Modal -->
        <div class="modal-body">
          <form>
            <div class="form-group">
              <label>Cỡ Combo</label>
              <select class="form-control float-right w-50" id="sel-create-combo">
                <option value="Small">S</option>
                <option value="Medium">M</option>
                <option value="Large">L</option>
              </select>
            </div>

            <div class="form-group">
              <label>Đường kính Pizza</label>
              <input class="form-control float-right w-50" id="inp-create-dk" disabled>
            </div>

            <div class="form-group">
              <label>Sườn nướng (miếng)</label>
              <input class="form-control float-right w-50" id="inp-create-suon" disabled>
            </div>

            <div class="form-group">
              <label>Salad</label>
              <input class="form-control float-right w-50" id="inp-create-salad" disabled>
            </div>

            <div class="form-group">
              <label>Số lượng nước uống</label>
              <input class="form-control float-right w-50" id="inp-create-number" disabled>
            </div>

            <div class="form-group">
              <label>Thành tiền</label>
              <input class="form-control float-right w-50" id="inp-create-price" disabled>
            </div>

            <div class="form-group">
              <label>Loại pizza</label>
              <select class="form-control float-right w-50" id="sel-create-pizza">
                <option value="Seafood">Hải sản</option>
                <option value="Hawaii">Hawaii</option>
                <option value="Bacon">Thịt hun khói</option>
              </select>
            </div>

            <div class="form-group">
              <label>Voucher ID</label>
              <input type="number" class="form-control float-right w-50" id="inp-create-voucher">
            </div>

            <div class="form-group">
              <label>Đồ uống</label>
              <select class="form-control float-right w-50" id="sel-create-drink">
              </select>
            </div>

            <div class="form-group">
              <label>Họ và tên <span class="text-danger">(*)</span></label>
              <input class="form-control float-right w-50" id="inp-create-name">
            </div>

            <div class="form-group">
              <label>Email</label>
              <input type="email" class="form-control float-right w-50" id="inp-create-email">
            </div>

            <div class="form-group">
              <label>Số điện thoại <span class="text-danger">(*)</span></label>
              <input type="number" class="form-control float-right w-50" id="inp-create-phone" placeholder="0123456789">
            </div>

            <div class="form-group">
              <label>Địa chỉ <span class="text-danger">(*)</span></label>
              <input class="form-control float-right w-50" id="inp-create-address">
            </div>

            <div class="form-group">
              <label>Lời nhắn</label>
              <input class="form-control float-right w-50" id="inp-create-message">
            </div>
          </form>
        </div>

        <div class="modal-footer" style="flex-wrap: nowrap;">
          <button class="btn btn-warning w-50" id="btn-create">Create</button>
          <button class="btn btn-danger w-50" data-dismiss="modal">Cancel</button>
        </div>
      </div>
    </div>
  </div>

  <!-- Update Modal -->
  <div id="update-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title"> Update Order Status !!! </h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <!-- Body Modal -->
        <div class="modal-body">
          <form>
            <div class="form-group">
              <label>Order Code (Mã đơn hàng)</label>
              <input class="form-control float-right w-50" id="inp-update-code" disabled>
            </div>

            <div class="form-group">
              <label>Cỡ Combo</label>
              <input class="form-control float-right w-50" id="inp-update-combo" disabled>
            </div>

            <div class="form-group">
              <label>Loại pizza</label>
              <input class="form-control float-right w-50" id="inp-update-pizza" disabled>
            </div>

            <div class="form-group">
              <label>Đồ uống</label>
              <input class="form-control float-right w-50" id="inp-update-drink" disabled>
            </div>

            <div class="form-group">
              <label>Thành tiền</label>
              <input class="form-control float-right w-50" id="inp-update-price" disabled>
            </div>

            <div class="form-group">
              <label>Voucher ID</label>
              <input class="form-control float-right w-50" id="inp-update-voucher" disabled>
            </div>

            <div class="form-group">
              <label>Giảm giá</label>
              <input class="form-control float-right w-50" id="inp-update-discount" disabled>
            </div>

            <div class="form-group">
              <label>Họ và tên</label>
              <input class="form-control float-right w-50" id="inp-update-name" disabled>
            </div>

            <div class="form-group">
              <label>Email</label>
              <input class="form-control float-right w-50" id="inp-update-email" disabled>
            </div>

            <div class="form-group">
              <label>Số điện thoại</label>
              <input class="form-control float-right w-50" id="inp-update-phone" disabled>
            </div>

            <div class="form-group">
              <label>Địa chỉ</label>
              <input class="form-control float-right w-50" id="inp-update-address" disabled>
            </div>

            <div class="form-group">
              <label>Lời nhắn</label>
              <input class="form-control float-right w-50" id="inp-update-message" disabled>
            </div>

            <div class="form-group">
              <label> Trạng thái đơn hàng</label>
              <select class="form-control float-right w-50" id="sel-update-status">
                <option value="open">Open</option>
                <option value="cancel">Đã hủy</option>
                <option value="confirmed">Đã xác nhận</option>
              </select>
            </div>
          </form>
        </div>

        <div class="modal-footer" style="flex-wrap: nowrap;">
          <button class="btn btn-warning w-50" id="btn-update">Update Status</button>
          <button class="btn btn-danger w-50" data-dismiss="modal">Cancel</button>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Order Delete Confirmation</h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <label>Bạn có chắc chắn muốn xóa Order này không?</label>
        </div>
        <div class="modal-footer">
          <button class="btn btn-danger" id="btn-confirm-delete">Confirm</button>
          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        </div>
      </div>
    </div>
  </div>

</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // base url API
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365";

  // các combo Pizza
  const gCOMBO_SMALL = { kichCo: "Small", duongKinh: 20, suon: 2, salad: 200, soLuongNuoc: 2, price: 150000 };
  const gCOMBO_MEDIUM = { kichCo: "Medium", duongKinh: 25, suon: 4, salad: 300, soLuongNuoc: 3, price: 200000 };
  const gCOMBO_LARGE = { kichCo: "Large", duongKinh: 30, suon: 8, salad: 500, soLuongNuoc: 4, price: 250000 };

  var gOrdersArr = [];
  var orderSelected = {};

  var vOrdersTable = $('#table-orders').DataTable({
    columns: [
      { data: "orderCode" },
      { data: "kichCo" },
      { data: "loaiPizza" },
      { data: "idLoaiNuocUong" },
      { data: "thanhTien" },
      { data: "hoTen" },
      { data: "soDienThoai" },
      { data: "trangThai" }
    ],
    columnDefs: [{
      targets: 8,
      defaultContent: `
            <img title="Update Status" class="edit-btn" style="width: 20px;cursor:pointer;"
              src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png">
              &nbsp;&nbsp;&nbsp;
            <img title="Delete Order" class="delete-btn" style="width: 20px;cursor:pointer;"
              src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png">
          `
    }]
  });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  /**
   * Hàm load data vào table
   * Input: mảng orders
   * Output: table có dữ liệu
   */
  function filterTable(paramArr) {
    vOrdersTable.clear();
    vOrdersTable.rows.add(paramArr);
    vOrdersTable.draw();
  }

  function loadDrinkSelect(paramList) {
    for (const key in paramList) {
      $("<option>")
        .val(paramList[key].maNuocUong)
        .text(paramList[key].tenNuocUong)
        .appendTo("#sel-create-drink");
    }
  }

  function showComboData(paramCombo) {
    $("#inp-create-dk").val(paramCombo.duongKinh);
    $("#inp-create-suon").val(paramCombo.suon);
    $("#inp-create-salad").val(paramCombo.salad);
    $("#inp-create-number").val(paramCombo.soLuongNuoc);
    $("#inp-create-price").val(paramCombo.price);
  }

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  $(document).ready(onPageLoading);
  /**
   * Call API để get all orders và lưu vào mảng toàn cục gOrdersArr.
   * gOrdersArr được sử dụng cho mục đích filter về sau
  */
  // Hàm thực thi khi load trang
  function onPageLoading() {
    // 1 - R: Read
    // gọi api load dữ liệu orders
    apiGetAllOrders();
    // gọi api load dữ liệu drinks
    apiGetDrinkList();

    $("#btn-filter").click(filterClick);

    // load combo
    showComboData(gCOMBO_SMALL);
    $("#sel-create-combo").on("change", getComboSelected);
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function apiGetAllOrders() {
    $.ajax({
      url: gBASE_URL + "/orders",
      type: 'GET',
      dataType: 'json',
      async: false,
      success: function (res) {
        gOrdersArr = res;
        filterTable(gOrdersArr); // gọi hàm để load dữ liệu mảng orders vào table
      }
    });
  }

  function apiGetDrinkList() {
    "use strict";
    $.ajax({
      url: gBASE_URL + "/drinks",
      type: "GET",
      success: loadDrinkSelect,
      error: function (params) { alert(params.status); }
    });
  }

  function getComboSelected() {
    switch (this.value) {
      case "Small":
        showComboData(gCOMBO_SMALL);
        break;

      case "Medium":
        showComboData(gCOMBO_MEDIUM);
        break;

      case "Large":
        showComboData(gCOMBO_LARGE);
        break;
    }
  }

  function filterClick() {
    var filterArr = [];
    var selOrderStatus = $("#sel-order-status").val();
    var selPizzaType = $("#sel-pizza-type").val();

    if (selOrderStatus == "all" && selPizzaType == "all")
      filterArr = gOrdersArr;

    else if (selOrderStatus == "all" && selPizzaType != "all")
      for (var orderObj of gOrdersArr) {
        if (orderObj.loaiPizza == null) {
          var lowerCaseType = "";
        } else
          var lowerCaseType = orderObj.loaiPizza.toLowerCase();

        if (lowerCaseType.includes(selPizzaType))
          filterArr.push(orderObj);
      }

    else if (selOrderStatus != "all" && selPizzaType == "all")
      for (var orderObj of gOrdersArr) {
        if (selOrderStatus == orderObj.trangThai)
          filterArr.push(orderObj);
      }

    else
      for (var orderObj of gOrdersArr) {
        if (orderObj.loaiPizza == null) {
          var lowerCaseType = "";
        } else
          var lowerCaseType = orderObj.loaiPizza.toLowerCase();

        if (selOrderStatus == orderObj.trangThai && lowerCaseType.includes(selPizzaType))
          filterArr.push(orderObj);
      }

    filterTable(filterArr);
  }

</script>

</html>